Subject: [PATCH] GICv3: Fixing 32 bit compatibility

From: [email-masked] (Robert Richter)
Date: Tue, 9 Sep 2014 11:26:53 +0200

On 09.09.14 11:19:12, Uwe Kleine-K?nig wrote:
> On Tue, Sep 09, 2014 at 11:12:01AM +0200, Robert Richter wrote:
> > On 09.09.14 10:00:42, Uwe Kleine-K?nig wrote:
> > > On Mon, Sep 08, 2014 at 04:11:19PM +0200, Robert Richter wrote:
> > 
> > > > @@ -479,7 +479,7 @@ static void gic_raise_softirq(const struct cpumask *mask, unsigned int irq)
> > > >     smp_wmb();
> > > >  
> > > >     for_each_cpu_mask(cpu, *mask) {
> > > > -           u64 cluster_id = cpu_logical_map(cpu) & ~0xffUL;
> > > > +           u64 cluster_id = cpu_logical_map(cpu) & ~0xffULL;
> > > This doesn't change anything, does it?
> > 
> > It does, not in 64 bit but in 32 bit there unsigned long is 32
> > bit. So, bit masks are broken if you compile a 32 bit kernel.
> Can you make an example where the result actually changes?

Upper 32 bits will be cleared above.

> > > I wonder if it would be cleaner to use (u64)0xff here.
> > 
> > No, that's ULL for. This is commonly used in x86 too.
> I don't care much here, but I'd say ULL is to force an unsigned long
> long. If you want to make it obvious that you want a 64bit value, a cast
> to u64 makes this more clear.

ULL is no cast at all.

-Robert